Package com.meterware.httpunit

# Class MessageBodyWebRequest

java.lang.Object
com.meterware.httpunit.WebRequest
com.meterware.httpunit.MessageBodyWebRequest

Direct Known Subclasses:
  `PostMethodWebRequest`, `PutMethodWebRequest`

public abstract class MessageBodyWebRequest extends WebRequest
A web request which contains a non-empty message body. Note that such requests must use the `http` or `https` protocols.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`MessageBodyWebRequest.InputStreamMessageBody`
A method request message body read directly from an input stream.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected com.meterware.httpunit.protocol.MessageBody`
`_body`

### Fields inherited from class com.meterware.httpunit.WebRequest

`method`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`MessageBodyWebRequest(WebForm sourceForm)`
Constructs a web request for a form submitted via script.
`protected`
`MessageBodyWebRequest(WebForm sourceForm, com.meterware.httpunit.ParameterHolder parameterHolder, SubmitButton button, int x, int y)`
Constructs a web request for a form submitted via a button.
`protected`
`MessageBodyWebRequest(String urlString, boolean mimeEncoded)`
Constructs a web request using a specific absolute url string.
`protected`
`MessageBodyWebRequest(String urlString, com.meterware.httpunit.protocol.MessageBody messageBody)`
Constructs a web request using a specific absolute url string.
`protected`
`MessageBodyWebRequest(URL urlBase, String urlString, String target, boolean mimeEncoded)`
Constructs a web request with a specific target.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`completeRequest(URLConnection connection)`
Performs any additional processing necessary to complete the request.
`protected String`
`getContentType()`
Returns the content type of this request.
`protected com.meterware.httpunit.protocol.MessageBody`
`getMessageBody()`
Subclasses may override this method to provide a message body for the request.
`boolean`
`isMimeEncoded()`
Returns true if this request is to be MIME-encoded.
`protected void`
`writeMessageBody(OutputStream stream)`
Writes the contents of the message body to the specified stream.

### Methods inherited from class com.meterware.httpunit.WebRequest

`getCharacterSet, getHeaders, getMethod, getParameter, getParameterHolder, getParameterValues, getQueryString, getRequestParameterNames, getTarget, getURL, getURLBase, getURLString, isFileParameter, maySelectFile, removeParameter, selectFile, selectFile, selectFile, setHeaderField, setImageButtonClickPosition, setParameter, setParameter, setParameter, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### _body

protected com.meterware.httpunit.protocol.MessageBody _body

## Constructor Details

### MessageBodyWebRequest

protected MessageBodyWebRequest(String urlString, boolean mimeEncoded)
Constructs a web request using a specific absolute url string.

### MessageBodyWebRequest

protected MessageBodyWebRequest(String urlString, com.meterware.httpunit.protocol.MessageBody messageBody)
Constructs a web request using a specific absolute url string.

### MessageBodyWebRequest

protected MessageBodyWebRequest(URL urlBase, String urlString, String target, boolean mimeEncoded)
Constructs a web request with a specific target.

### MessageBodyWebRequest

protected MessageBodyWebRequest(WebForm sourceForm, com.meterware.httpunit.ParameterHolder parameterHolder, SubmitButton button, int x, int y)
Constructs a web request for a form submitted via a button.

Since:
  1.6

### MessageBodyWebRequest

protected MessageBodyWebRequest(WebForm sourceForm)
Constructs a web request for a form submitted via script.

## Method Details

### getMessageBody

protected com.meterware.httpunit.protocol.MessageBody getMessageBody()
Subclasses may override this method to provide a message body for the request.

### writeMessageBody

protected void writeMessageBody(OutputStream stream) throws IOException
Description copied from class: `WebRequest`
Writes the contents of the message body to the specified stream.

Overrides:
  `writeMessageBody` in class `WebRequest`
Throws:
  `IOException`

### completeRequest

protected void completeRequest(URLConnection connection) throws IOException
Performs any additional processing necessary to complete the request.

Overrides:
  `completeRequest` in class `WebRequest`
Throws:
  `IOException`

### getContentType

protected String getContentType()
Description copied from class: `WebRequest`
Returns the content type of this request. If null, no content is specified.

Overrides:
  `getContentType` in class `WebRequest`

### isMimeEncoded

public boolean isMimeEncoded()
Description copied from class: `WebRequest`
Returns true if this request is to be MIME-encoded.

Overrides:
  `isMimeEncoded` in class `WebRequest`